package arvores;

import ine5408.excecoes.ExcecaoEstruturaVazia;
import ine5408.excecoes.ExcecaoOperacaoIlegal;
import ine5408.excecoes.ExcecaoPosicaoIlegal;
import ine5408.pp.Visitante;

public class ArvoreNAria<T> implements ine5408.arvores.ArvoreNAria<T> {

	private T raiz;
	private ine5408.arvores.ArvoreNAria<T> pai;
	private ine5408.arvores.ArvoreNAria<T>[] subArvores;
	private int grau;

	@SuppressWarnings("unchecked")
	public ArvoreNAria(ine5408.arvores.ArvoreNAria<T> pai, int n) {
		this.pai = pai;
		grau = n;
		subArvores = (ArvoreNAria<T>[]) new Object[grau];
	}

	public boolean ehFolha() {
		boolean temArvore = false;
		for (ine5408.arvores.ArvoreNAria<T> s : subArvores)
			if (s != null)
				temArvore = true;
		return !estaVazia() && !temArvore;
	}

	public boolean estaCheia() {
		return false;
	}

	public boolean estaVazia() {
		return raiz == null;
	}

	public void esvazie() {
		raiz = null;
		subArvores = null;
		grau = -1;

	}

	public void recebaVisitanteEmLargura(Visitante<T> arg0) {
		// TODO Auto-generated method stub

	}

	public void recebaVisitanteEmProfundidade(Visitante<T> arg0) {
		// TODO Auto-generated method stub

	}

	public int retorneAltura() {
		// TODO Auto-generated method stub
		return 0;
	}

	public ine5408.arvores.ArvoreNAria<T> retorneArvoreDaPosicao(int posicao)
			throws ExcecaoEstruturaVazia, ExcecaoPosicaoIlegal {
		if (estaVazia())
			throw new ExcecaoEstruturaVazia();
		if (posicao < 1 || posicao > grau)
			throw new ExcecaoPosicaoIlegal(posicao);
		return subArvores[posicao];
	}

	public int retorneGrau() {
		return grau;
	}

	public T retorneRaiz() throws ExcecaoEstruturaVazia {
		if (estaVazia())
			throw new ExcecaoEstruturaVazia();
		return raiz;
	}

	public int retorneTamanho() {
		int tamanho = 0;
		int tamanhoDasSubarvores = 0;
		if (!estaVazia()) {
			for (int i = 0; i < subArvores.length; i++)
				tamanhoDasSubarvores += subArvores[i].retorneTamanho();
			tamanho = 1 + tamanhoDasSubarvores;
		}

		return tamanho;
	}

	public void substituaArvoreDaPosicao(
			ine5408.arvores.ArvoreNAria<T> subArvore, int posicao)
			throws ExcecaoEstruturaVazia, ExcecaoPosicaoIlegal,
			ExcecaoOperacaoIlegal {
		if (estaVazia())
			throw new ExcecaoEstruturaVazia();
		if (posicao < 1 || posicao > grau)
			throw new ExcecaoPosicaoIlegal(posicao);
		
		subArvores[posicao] = subArvore;
	}

	public void substituaRaiz(T dado) {
		raiz = dado;
	}

}
