package fila;

import ine5408.excecoes.ExcecaoEstruturaCheia;
import ine5408.excecoes.ExcecaoEstruturaVazia;
import ine5408.lineares.Fila;
import ine5408.lineares.Lista;
import ine5408.pp.Visitante;
import lista.ListaDuplamenteEncadeada;

public class FilaBaseadaEmLDE<T> implements Fila<T> {

	Lista<T> listaDeArmazenamento;

	public FilaBaseadaEmLDE() {
		listaDeArmazenamento = new ListaDuplamenteEncadeada<T>();
	}

	public boolean estaCheia() {
		return false;
	}

	public boolean estaVazia() {
		return listaDeArmazenamento.estaVazia();
	}

	public void esvazie() {
		listaDeArmazenamento.esvazie();
	}

	public void insira(T dado) throws ExcecaoEstruturaCheia {
		listaDeArmazenamento.insiraNoFim(dado);
	}

	public void recebaVisitante(Visitante<T> visitante) {
		listaDeArmazenamento.recebaVisitante(visitante);
	}

	public T remova() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.removaDoInicio();
	}

	public T retorneDoFim() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.retorneDoFim();
	}

	public T retorneDoInicio() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.retorneDoInicio();
	}

	public int retorneTamanho() {
		return listaDeArmazenamento.retorneTamanho();
	}

}
