package fila;

import ine5408.excecoes.ExcecaoEstruturaCheia;
import ine5408.excecoes.ExcecaoEstruturaVazia;
import ine5408.lineares.Fila;
import ine5408.lineares.Lista;
import ine5408.pp.Visitante;
import lista.ListaEncadeadaRecursiva;

public class FilaBaseadaEmLER<T> implements Fila<T> {

	Lista<T> listaDeArmazenamento;

	public FilaBaseadaEmLER() {
		listaDeArmazenamento = new ListaEncadeadaRecursiva<T>();
	}

	public boolean estaCheia() {
		return false;
	}

	public boolean estaVazia() {
		return listaDeArmazenamento.estaVazia();
	}

	public void esvazie() {
		listaDeArmazenamento.esvazie();
	}

	public void insira(T dado) throws ExcecaoEstruturaCheia {
		listaDeArmazenamento.insiraNoFim(dado);
	}

	public void recebaVisitante(Visitante<T> v) {
		listaDeArmazenamento.recebaVisitante(v);
	}

	public T remova() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.removaDoInicio();
	}

	public T retorneDoFim() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.retorneDoFim();
	}

	public T retorneDoInicio() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.retorneDoInicio();
	}

	public int retorneTamanho() {
		return listaDeArmazenamento.retorneTamanho();
	}

}
