package fila;

import ine5408.excecoes.ExcecaoEstruturaCheia;
import ine5408.excecoes.ExcecaoEstruturaVazia;
import ine5408.lineares.Fila;
import ine5408.pp.Visitante;

public class FilaCircular<T> implements Fila<T> {

	private T[] array;
	private int numDeDados;
	private int tamanhoArray;
	private int início;

	@SuppressWarnings("unchecked")
	public FilaCircular(int tam) {
		array = (T[]) new Object[tam];
		numDeDados = início = 0;
		tamanhoArray = tam;
	}

	public boolean estaCheia() {
		return numDeDados == tamanhoArray;
	}

	public boolean estaVazia() {
		return numDeDados == 0;
	}

	@SuppressWarnings("unchecked")
	public void esvazie() {
		numDeDados = 0;
		array = (T[]) new Object[tamanhoArray];
	}

	public void insira(T dado) throws ExcecaoEstruturaCheia {
		if (numDeDados == tamanhoArray)
			throw new ExcecaoEstruturaCheia();

		array[(início + numDeDados) % tamanhoArray] = dado;
		numDeDados++;
	}

	public void recebaVisitante(Visitante<T> v) {
		for (int i = 0, atual = início; i < numDeDados && !v.satisfeito(); i++, atual = (atual + 1)
				% tamanhoArray)
			v.visite(array[atual]);
	}

	public T remova() throws ExcecaoEstruturaVazia {
		if (estaVazia())
			throw new ExcecaoEstruturaVazia();

		T retorno = array[início];
		array[início] = null;
		início = (início + 1) % tamanhoArray;
		numDeDados--;
		return retorno;
	}

	public T retorneDoFim() throws ExcecaoEstruturaVazia {
		if (estaVazia())
			throw new ExcecaoEstruturaVazia();

		return array[(início + numDeDados - 1) % tamanhoArray];
	}

	public T retorneDoInicio() throws ExcecaoEstruturaVazia {
		if (estaVazia())
			throw new ExcecaoEstruturaVazia();

		return array[início];
	}

	public int retorneTamanho() {
		return numDeDados;
	}

}
