package pilha;

import ine5408.excecoes.ExcecaoEstruturaCheia;
import ine5408.excecoes.ExcecaoEstruturaVazia;
import ine5408.pp.Visitante;

public class PilhaBaseadaEmArray<T> implements ine5408.lineares.Pilha<T> {

	private T[] array;
	private int topo;
	private int numDeDados;
	private int tamanhoDoArray;

	@SuppressWarnings("unchecked")
	public PilhaBaseadaEmArray(int tam) {
		tamanhoDoArray = tam;
		array = (T[]) new Object[tamanhoDoArray];
		numDeDados = 0;
		topo = -1;
	}

	public T desempilhe() throws ExcecaoEstruturaVazia {
		if (estaVazia())
			throw new ExcecaoEstruturaVazia();
		T retornado = array[topo];
		topo--;
		numDeDados--;
		return retornado;

	}

	public void empilhe(T dado) throws ExcecaoEstruturaCheia {
		if (topo + 1 == tamanhoDoArray)
			throw new ExcecaoEstruturaCheia();
		topo++;
		array[topo] = dado;
		numDeDados++;
	}

	public boolean estaCheia() {
		return numDeDados == tamanhoDoArray;
	}

	public boolean estaVazia() {
		return numDeDados == 0;
	}

	@SuppressWarnings("unchecked")
	public void esvazie() {
		array = (T[]) new Object[tamanhoDoArray];
		numDeDados = topo = 0;
	}

	public void recebaVisitante(Visitante<T> v) {
		for (int i = 0; i < numDeDados && !v.satisfeito(); i++)
			v.visite(array[i]);
	}

	public T retorneDoFim() throws ExcecaoEstruturaVazia {
		if (estaVazia())
			throw new ExcecaoEstruturaVazia();
		return array[0];
	}

	public T retorneDoInicio() throws ExcecaoEstruturaVazia {
		if (estaVazia())
			throw new ExcecaoEstruturaVazia();
		return array[topo];
	}

	public int retorneTamanho() {
		return numDeDados;
	}

	public T retorneTopo() throws ExcecaoEstruturaVazia {
		if (estaVazia())
			throw new ExcecaoEstruturaVazia();
		return array[topo];
	}

}
