package pilha;

import ine5408.excecoes.ExcecaoEstruturaCheia;
import ine5408.excecoes.ExcecaoEstruturaVazia;
import ine5408.excecoes.ExcecaoPosicaoIlegal;
import ine5408.lineares.Lista;
import ine5408.lineares.Pilha;
import ine5408.pp.Visitante;
import lista.ListaDuplamenteEncadeada;

public class PilhaBaseadaEmLDE<T> implements Pilha<T> {

	Lista<T> listaDeArmazenamento;

	public PilhaBaseadaEmLDE() {
		listaDeArmazenamento = new ListaDuplamenteEncadeada<T>();
	}

	public T desempilhe() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.removaDoInicio();
	}

	public void empilhe(T dado) throws ExcecaoEstruturaCheia {
		listaDeArmazenamento.insiraNoInicio(dado);
	}

	public boolean estaCheia() {
		return listaDeArmazenamento.estaCheia();
	}

	public boolean estaVazia() {
		return listaDeArmazenamento.estaVazia();
	}

	public void esvazie() {
		listaDeArmazenamento.esvazie();
	}

	public void recebaVisitante(Visitante<T> v) {
		listaDeArmazenamento.recebaVisitante(v);
	}

	public T retorneDaPosicao(int n) throws ExcecaoEstruturaVazia,
			ExcecaoPosicaoIlegal {
		if (estaVazia())
			throw new ExcecaoEstruturaVazia();
		if (retorneTamanho() <= n)
			throw new ExcecaoPosicaoIlegal(n);
		Pilha<T> aux = new PilhaBaseadaEmLDE<T>();
		int i = 0;
		while (i < n) {
			aux.empilhe(desempilhe());
			i++;
		}
		T retorno = retorneTopo();
		i = 0;
		while (i < n) {
			empilhe(aux.desempilhe());
			i++;
		}

		return retorno;
	}

	public T retorneDoFim() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.retorneDoFim();
	}

	public T retorneDoInicio() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.retorneDoInicio();
	}

	public int retorneTamanho() {
		return listaDeArmazenamento.retorneTamanho();
	}

	public T retorneTopo() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.retorneDoInicio();
	}

}
