package pilha;

import ine5408.excecoes.ExcecaoEstruturaCheia;
import ine5408.excecoes.ExcecaoEstruturaVazia;
import ine5408.lineares.Lista;
import ine5408.lineares.Pilha;
import ine5408.pp.Visitante;
import lista.ListaEncadeadaRecursiva;

public class PilhaBaseadaEmLER<T> implements Pilha<T> {

	Lista<T> listaDeArmazenamento;

	public PilhaBaseadaEmLER() {
		listaDeArmazenamento = new ListaEncadeadaRecursiva<T>();
	}

	public T desempilhe() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.removaDoInicio();
	}

	public void empilhe(T dado) throws ExcecaoEstruturaCheia {
		listaDeArmazenamento.insiraNoInicio(dado);
	}

	public boolean estaCheia() {
		return listaDeArmazenamento.estaCheia();
	}

	public boolean estaVazia() {
		return listaDeArmazenamento.estaVazia();
	}

	public void esvazie() {
		listaDeArmazenamento.esvazie();
	}

	public void recebaVisitante(Visitante<T> v) {
		listaDeArmazenamento.recebaVisitante(v);
	}

	public T retorneDoFim() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.retorneDoFim();
	}

	public T retorneDoInicio() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.retorneDoInicio();
	}

	public int retorneTamanho() {
		return listaDeArmazenamento.retorneTamanho();
	}

	public T retorneTopo() throws ExcecaoEstruturaVazia {
		return listaDeArmazenamento.retorneDoInicio();
	}

}
