package testes.listaEncadeadaRecursiva;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;
import ine5408.lineares.Lista;
import ine5408.pp.Iterador;
import lista.ListaEncadeadaRecursiva;

import org.junit.Before;
import org.junit.Test;

public class TestesLuisFelipe {

	private Lista<String> lista;

	@Before
	public void prepararTestes() {
		lista = new ListaEncadeadaRecursiva<String>();
	}

	@Test
	public void testeEstaCheia() {
		assertFalse(lista.estaCheia());
	}

	@Test
	public void testeEstaVazia() {
		assertTrue(lista.estaVazia() == true);
	}

	@Test
	public void testeEsvazie() {
		lista.insiraNoInicio("apagado");
		lista.esvazie();
		assertTrue(lista.estaVazia());
	}

	@Test
	public void testeInsiraNaPosicao() {
		lista.insiraNoInicio("5");
		lista.insiraNoInicio("4");
		lista.insiraNoInicio("3");
		lista.insiraNoInicio("2");
		lista.insiraNoInicio("1");
		lista.insiraNaPosicao("b", 1);
		assertEquals("b", lista.retorneDaPosicao(1));
		assertEquals(6, lista.retorneTamanho());
		lista.insiraNaPosicao("c", 3);
		assertEquals("c", lista.retorneDaPosicao(3));

	}

	@Test
	public void testeInsiraNoFim() {
		lista.insiraNoFim("Teste");
		assertEquals("Teste", lista.retorneDoFim());

	}

	@Test
	public void testeInsiraNoInicio() {
		lista.insiraNoInicio("Teste");
		assertEquals("Teste", lista.retorneDoInicio());
	}

	@Test
	public void testeRemovaDaPosicao() {
		lista.insiraNoInicio("5");
		lista.insiraNoInicio("4");
		lista.insiraNoInicio("3");
		lista.insiraNoInicio("2");
		assertEquals("2", lista.removaDaPosicao(1));
		assertEquals(3, lista.retorneTamanho());
		assertEquals("3", lista.retorneDaPosicao(1));
	}

	@Test
	public void testeRemovaDoFim() {
		lista.insiraNoFim("1");
		lista.insiraNoFim("2");
		assertEquals("2", lista.removaDoFim());
		assertEquals("1", lista.retorneDoFim());

	}

	@Test
	public void testeRemovaDoInicio() {
		lista.insiraNoInicio("11");
		lista.insiraNoFim("fim");
		assertEquals("11", lista.removaDoInicio());
		assertEquals("fim", lista.retorneDoInicio());
	}

	@Test
	public void testeRetorneDaPosicao() {
		lista.insiraNoFim("a");
		lista.insiraNoFim("b");
		lista.insiraNoFim("c");
		lista.insiraNoFim("d");
		lista.insiraNoFim("e");
		lista.insiraNoFim("f");
		lista.insiraNoFim("g");
		assertEquals("a", lista.retorneDaPosicao(1));
	}

	@Test
	public void testeRetorneDoFim() {
		lista.insiraNoFim("aa");
		assertEquals("aa", lista.retorneDoFim());
	}

	@Test
	public void testeRetorneDoInicio() {
		lista.insiraNoInicio("Teste");
		assertEquals("Teste", lista.retorneDoInicio());
	}

	@Test
	public void testeRetorneIterador() {
		assertTrue(lista.retorneIterador() instanceof Iterador);

	}

	@Test
	public void testeRetorneTamanho() {
		assertEquals(0, lista.retorneTamanho());
		lista.insiraNoInicio("aa");
		assertEquals(1, lista.retorneTamanho());

	}

	@Test
	public void testeSubstituaDaPosicao() {
		lista.insiraNoInicio("5");
		lista.insiraNoInicio("4");
		lista.insiraNoInicio("3");
		lista.insiraNoInicio("2");
		lista.substituaDaPosicao("um", 1);
		assertEquals("um", lista.retorneDaPosicao(1));
	}

	@Test
	public void testeSubstituaDoFim() {
		lista.insiraNoFim("aaa");
		lista.insiraNoFim("bbb");
		lista.substituaDoFim("ccc");
		assertEquals("ccc", lista.retorneDoFim());
	}

	@Test
	public void testeSubstituaDoInicio() {
		lista.insiraNoFim("aaa");
		lista.insiraNoInicio("bbb");
		lista.substituaDoInicio("ccc");
		assertEquals("ccc", lista.retorneDoInicio());

	}

	// @Test
	// public void testRecebaVisitante() {
	// fail("Not yet implemented");
	//
	// }
	//
	// @Test
	// public void testPertence() {
	// fail("Not yet implemented");
	// }
	//
	// @Test
	// public void testRemovaIguais() {
	// fail("Not yet implemented");
	// }
	//
	// @Test
	// public void testRemovaIgual() {
	// fail("Not yet implemented");
	// }
	//
	// @Test
	// public void testTemIguais() {
	// fail("Not yet implemented");
	// }
	//
	// @Test
	// public void testTemIgual() {
	// fail("Not yet implemented");
	// }

}
