package testes.pilhaBaseadaEmArray;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;
import ine5408.lineares.Pilha;

import org.junit.Before;
import org.junit.Test;

import pilha.PilhaBaseadaEmArray;
import testes.VisitanteConcatenador;

public class TestesDePilhaBaseadaEmArray {

	private Pilha<String> pilhaTestada;

	@Before
	public void setUp() {
		pilhaTestada = new PilhaBaseadaEmArray<String>(10);
	}

	@Test
	public void testDesempilhe() {
		pilhaTestada.empilhe("a");
		pilhaTestada.empilhe("b");
		pilhaTestada.desempilhe();
		assertEquals("a", pilhaTestada.retorneTopo());
	}

	@Test
	public void testEmpilhe() {
		pilhaTestada.empilhe("a");
		assertEquals("a", pilhaTestada.retorneTopo());
	}

	@Test
	public void testEstaCheia() {
		for (int i = 0; i < 10; i++)
			pilhaTestada.empilhe(String.valueOf(i));

		assertTrue(pilhaTestada.estaCheia());
	}

	@Test
	public void testEstaVazia() {
		assertTrue(pilhaTestada.estaVazia());
	}

	@Test
	public void testEsvazie() {
		for (int i = 0; i < 10; i++)
			pilhaTestada.empilhe(String.valueOf(i));
		pilhaTestada.esvazie();
		assertTrue(pilhaTestada.estaVazia());
	}

	@Test
	public void testRecebaVisitante() {
		pilhaTestada.empilhe("a");
		pilhaTestada.empilhe("b");
		VisitanteConcatenador v = new VisitanteConcatenador();
		pilhaTestada.recebaVisitante(v);

		assertEquals("ab", v.retorneDados());
	}

	@Test
	public void testRetorneDoFim() {
		pilhaTestada.empilhe("a");
		pilhaTestada.empilhe("b");
		assertEquals("a", pilhaTestada.retorneDoFim());
	}

	@Test
	public void testRetorneDoInicio() {
		pilhaTestada.empilhe("a");
		pilhaTestada.empilhe("b");
		assertEquals("b", pilhaTestada.retorneTopo());
	}

	@Test
	public void testRetorneTamanho() {

		pilhaTestada.empilhe("a");
		assertEquals(1, pilhaTestada.retorneTamanho());
	}

	@Test
	public void testRetorneTopo() {
		pilhaTestada.empilhe("a");
		pilhaTestada.empilhe("b");
		assertEquals("b", pilhaTestada.retorneTopo());
	}

}
