package testes.tabelaDeHash;

import static org.junit.Assert.assertTrue;
import ine5408.th.FuncaoG;

import java.util.Random;

import org.junit.Before;
import org.junit.Test;

import tabelaDeHash.FuncaoGMiddleSquare;

public class TestesFuncaoGMiddleSquare {

	private FuncaoG fG;
	private final int k = 6, numDePosicoes = (int) Math.pow(2, k);
	private final int elementos = 20000000;
	private final double tolerancia = 0.25;

	private final Random r = new Random();

	@Before
	public void prepararTestes() {
		fG = new FuncaoGMiddleSquare(32, k);
	}

	@Test
	public void testeEspalhamento() {
		final int[] quantidades = new int[numDePosicoes];
		int maiorDiferenca = 0;

		for (int i = 0; i < elementos; i++)
			quantidades[fG.getValor(r.nextInt())]++;

		for (int i = 0; i < quantidades.length - 1; i++) {
			final int difAtual = Math.abs(quantidades[i] - quantidades[i + 1]);
			if (difAtual > maiorDiferenca)
				maiorDiferenca = difAtual;
		}

		final int ideal = elementos / numDePosicoes;
		final int margem = (int) (tolerancia * ideal);

		assertTrue(maiorDiferenca < margem);
	}

	@Test
	public void testeQueInteirosAleatoriosCaemNaFaixa() {
		int pos;

		for (int i = 0; i < elementos; i++) {
			pos = fG.getValor(r.nextInt());
			assertTrue(pos >= 0 && pos < numDePosicoes);
		}
	}

}
